unit hiStrCase;

interface

uses Kol,Share,Debug;

type
  THIStrCase = class(TDebug)
   private
   public
    _prop_Type:procedure(var Str:string) of object;

    _data_Str:THI_Event;
    _event_onModify:THI_Event;

    procedure _work_doModify(var _Data:TData; Index:word);
    procedure Lower(var Str:string);
    procedure Upper(var Str:string);
    procedure ProperCase(var Str:string);    
  end;

implementation

procedure THIStrCase._work_doModify;
var
  str:string;
begin
   str := ReadString(_Data,_data_Str,'');
   _prop_Type(str);
   _hi_OnEvent(_event_onModify,str);
end;

procedure THIStrCase.Lower;
var i:integer;
begin
   for i := 1 to Length(Str) do
    if (Str[i] in [ 'A'..'Z' ]) or (Str[i] in [ ''..'' ]) then
      Str[i] := chr(ord(Str[i]) or $20)
    else if Str[i] = '' then
      Str[i] := chr(ord(Str[i]) or $10);
end;

procedure THIStrCase.Upper;
var i:integer;
begin
   for i := 1 to Length(Str) do
    if (Str[i] in [ 'a'..'z' ]) or (Str[i] in [ ''..'' ]) then
      Str[i] := char( ord(Str[i]) and not $20 )
    else if Str[i] = '' then
      Str[i] := char( ord(Str[i]) and not $10 );
end;

procedure THIStrCase.ProperCase;
var i: integer;
begin
   Lower(Str);
   for i := 1 to length(Str) do
     if (i = 1) or (Str[i-1] = ' ') then
       if (Str[i] in [ 'a'..'z' ]) or (Str[i] in [ ''..'' ]) then
         Str[i] := char(ord(Str[i]) and not $20)
       else if (Str[i] = '') then
         Str[i] := char(ord(Str[i]) and not $10);
end;

end.